Loading...
Searching...
No Matches
pcl::registration::CorrespondenceRejectionOrganizedBoundary Class Reference
Module registration

The CorrespondenceRejectionOrganizedBoundary class implements a simple correspondence rejection measure. More...

`#include <pcl/registration/correspondence_rejection_organized_boundary.h>`

Inheritance diagram for pcl::registration::CorrespondenceRejectionOrganizedBoundary:

## Public Member Functions

| CorrespondenceRejectionOrganizedBoundary ()=default
| Empty constructor.
void | getRemainingCorrespondences (const pcl::Correspondences &original_correspondences, pcl::Correspondences &remaining_correspondences) override
| Get a list of valid correspondences after rejection from the original set of correspondences.
void | setNumberOfBoundaryNaNs (int val)
template<typename PointT>
void | setInputSource (const typename pcl::PointCloud< PointT >::ConstPtr &cloud)
template<typename PointT>
void | setInputTarget (const typename pcl::PointCloud< PointT >::ConstPtr &cloud)
bool | requiresSourcePoints () const override
| See if this rejector requires source points.
void | setSourcePoints (pcl::PCLPointCloud2::ConstPtr cloud2) override
| Blob method for setting the source cloud.
bool | requiresTargetPoints () const override
| See if this rejector requires a target cloud.
void | setTargetPoints (pcl::PCLPointCloud2::ConstPtr cloud2) override
| Method for setting the target cloud.
virtual bool | updateSource (const Eigen::Matrix4d &)
Public Member Functions inherited from pcl::registration::CorrespondenceRejector
| CorrespondenceRejector ()=default
| Empty constructor.
virtual | ~CorrespondenceRejector ()=default
| Empty destructor.
virtual void | setInputCorrespondences (const CorrespondencesConstPtr &correspondences)
| Provide a pointer to the vector of the input correspondences.
CorrespondencesConstPtr | getInputCorrespondences ()
| Get a pointer to the vector of the input correspondences.
void | getCorrespondences (pcl::Correspondences &correspondences)
| Run correspondence rejection.
void | getRejectedQueryIndices (const pcl::Correspondences &correspondences, pcl::Indices &indices)
| Determine the indices of query points of correspondences that have been rejected, i.e., the difference between the input correspondences (set via setInputCorrespondences) and the given correspondence vector.
const std::string & | getClassName () const
| Get a string representation of the name of this class.
virtual bool | requiresSourceNormals () const
| See if this rejector requires source normals.
virtual void | setSourceNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the source normals.
virtual bool | requiresTargetNormals () const
| See if this rejector requires target normals.
virtual void | setTargetNormals (pcl::PCLPointCloud2::ConstPtr)
| Abstract method for setting the target normals.

## Protected Types

using | DataContainerPtr = DataContainerInterface::Ptr

## Protected Member Functions

void | applyRejection (pcl::Correspondences &correspondences) override
| Apply the rejection algorithm.

## Protected Attributes

int | boundary_nans_threshold_ {8}
int | window_size_ {5}
float | depth_step_threshold_ {0.025f}
DataContainerPtr | data_container_
Protected Attributes inherited from pcl::registration::CorrespondenceRejector
std::string | rejection_name_ {}
| The name of the rejection method.
CorrespondencesConstPtr | input_correspondences_
| The input correspondences.

## Additional Inherited Members

Public Types inherited from pcl::registration::CorrespondenceRejector
using | Ptr = shared_ptr<CorrespondenceRejector>
using | ConstPtr = shared_ptr<const CorrespondenceRejector>

## Detailed Description

The CorrespondenceRejectionOrganizedBoundary class implements a simple correspondence rejection measure.

For each pair of points in correspondence, it checks whether they are on the boundary of a silhouette. This is done by counting the number of NaN dexels in a window around the points (the threshold and window size can be set by the user).

Note
  Both the source and the target clouds need to be organized, otherwise all the correspondences will be rejected.

Author
  Alexandru E. Ichim

Definition at line 58 of file correspondence_rejection_organized_boundary.h.

## Member Typedef Documentation

## DataContainerPtr

using pcl::registration::CorrespondenceRejectionOrganizedBoundary::DataContainerPtr = DataContainerInterface::Ptr

protected

Definition at line 146 of file correspondence_rejection_organized_boundary.h.

## Constructor & Destructor Documentation

## CorrespondenceRejectionOrganizedBoundary()

pcl::registration::CorrespondenceRejectionOrganizedBoundary::CorrespondenceRejectionOrganizedBoundary | ( |  | ) |

default

Empty constructor.

## Member Function Documentation

## applyRejection()

void pcl::registration::CorrespondenceRejectionOrganizedBoundary::applyRejection | ( | pcl::Correspondences & | correspondences | ) |

inline override protected virtual

Apply the rejection algorithm.

Parameters

  [out] | correspondences | the set of resultant correspondences.

Implements pcl::registration::CorrespondenceRejector.

Definition at line 137 of file correspondence_rejection_organized_boundary.h.

References getRemainingCorrespondences(), and pcl::registration::CorrespondenceRejector::input_correspondences_.

## getRemainingCorrespondences()

void pcl::registration::CorrespondenceRejectionOrganizedBoundary::getRemainingCorrespondences | ( | const pcl::Correspondences & | original_correspondences,
|  | pcl::Correspondences & | remaining_correspondences )

override virtual

Get a list of valid correspondences after rejection from the original set of correspondences.

Pure virtual. Compared to getCorrespondences this function is stateless, i.e., input correspondences do not need to be provided beforehand, but are directly provided in the function call.

Parameters

  [in] | original_correspondences | the set of initial correspondences given
  [out] | remaining_correspondences | the resultant filtered set of remaining correspondences

Implements pcl::registration::CorrespondenceRejector.

Referenced by applyRejection().

## requiresSourcePoints()

bool pcl::registration::CorrespondenceRejectionOrganizedBoundary::requiresSourcePoints | ( |  | ) | const

inline override virtual

See if this rejector requires source points.

Reimplemented from pcl::registration::CorrespondenceRejector.

Definition at line 96 of file correspondence_rejection_organized_boundary.h.

## requiresTargetPoints()

bool pcl::registration::CorrespondenceRejectionOrganizedBoundary::requiresTargetPoints | ( |  | ) | const

inline override virtual

See if this rejector requires a target cloud.

Reimplemented from pcl::registration::CorrespondenceRejector.

Definition at line 112 of file correspondence_rejection_organized_boundary.h.

## setInputSource()

template<typename PointT>

void pcl::registration::CorrespondenceRejectionOrganizedBoundary::setInputSource | ( | const typename pcl::PointCloud< PointT >::ConstPtr & | cloud | ) |

inline

Definition at line 76 of file correspondence_rejection_organized_boundary.h.

References data_container_, and setInputSource().

Referenced by setInputSource(), and setSourcePoints().

## setInputTarget()

template<typename PointT>

void pcl::registration::CorrespondenceRejectionOrganizedBoundary::setInputTarget | ( | const typename pcl::PointCloud< PointT >::ConstPtr & | cloud | ) |

inline

Definition at line 86 of file correspondence_rejection_organized_boundary.h.

References data_container_, and setInputTarget().

Referenced by setInputTarget(), and setTargetPoints().

## setNumberOfBoundaryNaNs()

void pcl::registration::CorrespondenceRejectionOrganizedBoundary::setNumberOfBoundaryNaNs | ( | int | val | ) |

inline

Definition at line 69 of file correspondence_rejection_organized_boundary.h.

References boundary_nans_threshold_.

## setSourcePoints()

void pcl::registration::CorrespondenceRejectionOrganizedBoundary::setSourcePoints | ( | pcl::PCLPointCloud2::ConstPtr | cloud2 | ) |

inline override virtual

Blob method for setting the source cloud.

Reimplemented from pcl::registration::CorrespondenceRejector.

Definition at line 103 of file correspondence_rejection_organized_boundary.h.

References pcl::fromPCLPointCloud2(), and setInputSource().

## setTargetPoints()

void pcl::registration::CorrespondenceRejectionOrganizedBoundary::setTargetPoints | ( | pcl::PCLPointCloud2::ConstPtr | cloud2 | ) |

inline override virtual

Method for setting the target cloud.

Reimplemented from pcl::registration::CorrespondenceRejector.

Definition at line 119 of file correspondence_rejection_organized_boundary.h.

References pcl::fromPCLPointCloud2(), and setInputTarget().

## updateSource()

virtual bool pcl::registration::CorrespondenceRejectionOrganizedBoundary::updateSource | ( | const Eigen::Matrix4d & |  | ) |

inline virtual

Definition at line 127 of file correspondence_rejection_organized_boundary.h.

## Member Data Documentation

## boundary_nans_threshold_

int pcl::registration::CorrespondenceRejectionOrganizedBoundary::boundary_nans_threshold_ {8}

protected

Definition at line 142 of file correspondence_rejection_organized_boundary.h.

Referenced by setNumberOfBoundaryNaNs().

## data_container_

DataContainerPtr pcl::registration::CorrespondenceRejectionOrganizedBoundary::data_container_

protected

Definition at line 147 of file correspondence_rejection_organized_boundary.h.

Referenced by setInputSource(), and setInputTarget().

## depth_step_threshold_

float pcl::registration::CorrespondenceRejectionOrganizedBoundary::depth_step_threshold_ {0.025f}

protected

Definition at line 144 of file correspondence_rejection_organized_boundary.h.

## window_size_

int pcl::registration::CorrespondenceRejectionOrganizedBoundary::window_size_ {5}

protected

Definition at line 143 of file correspondence_rejection_organized_boundary.h.

The documentation for this class was generated from the following file:

- pcl/registration/correspondence_rejection_organized_boundary.h